#!/bin/bash
#
# SEISAN definitions to be sourced from users .bashrc file 
#
#
# set platform, used for compilation, can be linux, solaris, linux64 or macosx
#
# export SEISARCH="solaris"
  export SEISARCH="macosx"
#
#    set SEISAN top directory
#
  export SEISAN_TOP="/Users/crawford/SEISAN"   # top directory for data
  export SEISAN_RES="/Users/crawford/seisan_v8.3_macosx_ppc"   # top directory for programs
#
# set editor
#
# export SEISAN_EDITOR="gvim"
# export SEISAN_EDITOR="emacs"
  export SEISAN_EDITOR="vi"
#
# rename laser printers
#
#  export PRINTER="hpbw2"
#  export IMAGEN="hpbw2"
#
# set X and Y scaling for Postscript output
#   some examples:  A4     x=0.55,y=1.0
#                   Letter x=0.55,y=0.9
#
  export SEISAN_PSSCALE_X="0.55"
  export SEISAN_PSSCALE_Y="1.0"
#
# set default data base
#
  export DEF_BASE=TEST
#
# set up search PATH
#
#    set pro_path =($SEISAN_RES/PRO)
   export pro_path="$SEISAN_RES/PRO"
#  if( `echo $PATH | grep -c pro_path` == 0 ) then
    export PATH=$pro_path:$PATH
#  fi
#  set com_path = ($SEISAN_RES/COM)
   export com_path="$SEISAN_RES/COM"
#  if( `echo $PATH | grep -c com_path` == 0 ) then
    export PATH=$com_path:$PATH
#  fi
#
# aliases for SEISAN
#
  alias pr='cd $SEISAN_RES/PRO'
  alias li='cd $SEISAN_RES/LIB'
  alias ic='cd $SEISAN_RES/INC'
  alias re='cd $SEISAN_TOP/REA'
  alias da='cd $SEISAN_TOP/DAT'
  alias wo='cd $SEISAN_TOP/WOR'
  alias wa='cd $SEISAN_TOP/WAV'
  alias ca='cd $SEISAN_TOP/CAL'
  alias co='cd $SEISAN_TOP/COM'
  alias in='cd $SEISAN_RES/INF'
#
# following lines are for the PITSA analysis package 
#
  export PITSAHOME="$SEISAN_TOP/DAT"
  export PITSA_CONFIG_PATH_ENV="$PITSAHOME/"
  export PITSA_PRINTDEF_PATH_ENV="$PITSAHOME/"
  export PITSA_PRINTDEF_NAME_ENV="8X11_landscape.PS"
#
# include seismo/LIB in LD_LIBRARY_PATH, needed by NANSEI # #if ($LD_LIBRARY_PATH /= '' ) then
  export LD_LIBRARY_PATH="$SEISAN_RES/LIB:$LD_LIBRARY_PATH"
#else
#  export LD_LIBRARY_PATH="$SEISAN_RES/LIB"
#fi
#
# set CLASSPATH for java app
#
#if ($CLASSPATH != '' ) then
  export CLASSPATH="$SEISAN_TOP/PRO:$SEISAN_TOP/PRO/jseisan.jar:$CLASSPATH"
#else
#  export CLASSPATH="$SEISAN_TOP/PRO:$SEISAN_TOP/PRO/jseisan.jar"
#fi
#
# aliases for Java tools
#
alias jseisan='java -DSEISAN_TOP=$SEISAN_RES -classpath $SEISAN_TOP/PRO/jseisan.jar SEISAN'
alias seisconf='java -DSEISAN_TOP=$SEISAN_RES -classpath $SEISAN_TOP/PRO/jseisan.jar SEISCONF'
alias sformat='java -DSEISAN_TOP=$SEISAN_RES -classpath $SEISAN_TOP/PRO/sformat.jar Sformat'
#
# set SEISAN extension code, this variable can be used to implement specific # code into SEISAN, at the moment used are:
#                BGS
#
export SEISAN_EXTENSION="none"
#
# set SAC library file to be linked to when compiling # export SACLIB="/usr/local/sac/lib/sacio.a"
